import { j as s } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as ss, useState as y, useMemo as j, useEffect as es } from "react";
import { isMobile as z } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { Table as N, Skeleton as ns } from "antd";
import ls from "../../BitzDrawer/index.mjs";
import is from "../../BitzLoadMore/index.mjs";
import rs from "../../BitzPagination/index.mjs";
import os from "../../BitzNoData/index.mjs";
import xs, { TableContext as ts } from "../Store/index.mjs";
import hs from "../TableSkeleton/index.mjs";
import { columnSort as fs, genColumnKey as C } from "../Store/utils/index.mjs";
import "./index.less.mjs";
import bs from "../../../node_modules/lodash-es/at.mjs";
const as = ({
  tableItemEmit: a = () => {
  },
  showPagination: M = !0,
  dataSource: e = [],
  total: m = 0,
  columns: t,
  loading: f = !1,
  skeletonNum: T = 2,
  skeletonRender: d,
  skeletonRowNum: L = 4,
  skeletonRowsWidth: k = ["35%", "100%", "100%", "60%"],
  tableOperationEmit: E = () => {
  },
  mobileLoadEmit: O = () => {
  },
  mobileRefreshEmit: D = () => {
  },
  operations: F = [],
  enableControlPage: K,
  pagination: P,
  paginationEmit: _ = () => {
  },
  mobilePageHeight: $ = 500,
  mobileCancelText: A = "取消",
  noDataTitle: U,
  noDataImg: H,
  color: V,
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  size: p,
  showTableTool: X = !0,
  tableAction: q,
  tableToolbar: G,
  selectionBar: J,
  scroll: r,
  resetPage: Q,
  ...h
}) => {
  const x = ss(ts), [R, v] = y(!1), [W, Y] = y({}), Z = j(() => (e == null ? void 0 : e.length) == m && (e == null ? void 0 : e.length) > 0, [e, m]), I = (l) => {
    v(!0), Y(l), a(l);
  }, g = () => {
    v(!1);
  }, u = (l) => {
    v(!1), E(l.type, W);
  }, b = j(() => {
    const l = (o) => o.map((i) => {
      const S = C(
        (i == null ? void 0 : i.key) || (i == null ? void 0 : i.dataIndex),
        i.index
      ), w = x.columnsMap[S];
      return w && w.show === !1 ? !1 : i.children ? {
        ...i,
        children: l(i.children)
      } : i;
    }).filter(Boolean), n = l(t);
    return [
      N.SELECTION_COLUMN,
      N.EXPAND_COLUMN,
      ...n.sort(fs(x.columnsMap))
    ];
  }, [x.columnsMap, t]);
  es(() => {
    if (t && t.length > 0) {
      const l = t.map(
        (n) => (
          // @ts-ignore
          C((n == null ? void 0 : n.key) ?? (n == null ? void 0 : n.dataIndex), n == null ? void 0 : n.dataIndex)
        )
      );
      x.setSortKeyColumns(l);
    }
  }, [t]);
  const B = j(() => r != null && r.x ? r : r != null && r.y ? e != null && e.length ? { x: 1e3, y: r.y } : { y: r.y } : e != null && e.length ? { x: 1e3 } : void 0, [e, r]), c = j(() => `${p ?? (x == null ? void 0 : x.tableSize) ?? "lg"}BitzTable`, [p, x.tableSize]);
  return /* @__PURE__ */ s.jsxs("div", { className: "bitzTableBlock", children: [
    !z && /* @__PURE__ */ s.jsxs("div", { className: `bitzTableContainer ${c}`, children: [
      X && /* @__PURE__ */ s.jsxs("div", { className: "bitzTableToolbarBlock", children: [
        q || /* @__PURE__ */ s.jsx("div", {}),
        G,
        (h == null ? void 0 : h.rowSelection) && /* @__PURE__ */ s.jsx(s.Fragment, { children: J })
      ] }),
      f ? /* @__PURE__ */ s.jsx(
        hs,
        {
          columns: b,
          dataLength: e == null ? void 0 : e.length,
          scroll: B,
          rowSelection: h.rowSelection,
          expandable: h.expandable,
          className: c
        }
      ) : /* @__PURE__ */ s.jsx(
        N,
        {
          columns: b,
          dataSource: e,
          loading: f,
          pagination: !1,
          scroll: B,
          ...h
        }
      ),
      M && (e == null ? void 0 : e.length) != 0 && /* @__PURE__ */ s.jsx("div", { className: "bitzTablePagination", children: /* @__PURE__ */ s.jsx(
        rs,
        {
          enableControl: K,
          pagination: P,
          total: m,
          dataSource: e,
          resetPage: Q,
          paginationEmit: _
        }
      ) })
    ] }),
    z && /* @__PURE__ */ s.jsxs(s.Fragment, { children: [
      (f || (e == null ? void 0 : e.length) > 0) && /* @__PURE__ */ s.jsx(
        is,
        {
          color: V,
          height: $,
          showNoMore: Z,
          refreshEmit: D,
          loadEmit: O,
          extra: /* @__PURE__ */ s.jsxs("div", { className: "mobileTable", children: [
            e == null ? void 0 : e.map((l, n) => /* @__PURE__ */ s.jsxs("div", { children: [
              /* @__PURE__ */ s.jsx("div", { className: "rowBox", children: b == null ? void 0 : b.map((o, i) => /* @__PURE__ */ s.jsx("div", { children: !(o != null && o.mobileHide) && /* @__PURE__ */ s.jsxs(
                "div",
                {
                  className: "row",
                  onClick: () => {
                    I(l);
                  },
                  children: [
                    /* @__PURE__ */ s.jsxs("div", { className: "label", children: [
                      o.title,
                      "："
                    ] }),
                    /* @__PURE__ */ s.jsx("div", { className: "value", children: o.render(
                      bs(l, o == null ? void 0 : o.dataIndex),
                      l,
                      n
                    ) })
                  ]
                }
              ) }, i)) }),
              /* @__PURE__ */ s.jsx("div", { className: "rowBoxLine" })
            ] }, n)),
            f && Array.from({ length: T }).map((l, n) => /* @__PURE__ */ s.jsxs("div", { children: [
              /* @__PURE__ */ s.jsx("div", { className: "rowBox", children: d ? d() : /* @__PURE__ */ s.jsx(
                ns,
                {
                  title: !1,
                  paragraph: {
                    rows: L,
                    width: k
                  },
                  active: !0
                }
              ) }),
              /* @__PURE__ */ s.jsx("div", { className: "rowBoxLine" })
            ] }, n)),
            /* @__PURE__ */ s.jsx(
              ls,
              {
                className: "tableMobileDrawer",
                open: R,
                placement: "bottom",
                height: "auto",
                closable: !1,
                onClose: g,
                children: /* @__PURE__ */ s.jsxs("div", { className: "drawerBox", children: [
                  /* @__PURE__ */ s.jsx("div", { className: "boxBody", children: F.map((l, n) => /* @__PURE__ */ s.jsx(
                    "div",
                    {
                      className: "operaList",
                      onClick: () => {
                        u(l);
                      },
                      children: l.label
                    },
                    n
                  )) }),
                  /* @__PURE__ */ s.jsx("div", { className: "boxLine" }),
                  /* @__PURE__ */ s.jsx("div", { className: "boxFooter", onClick: g, children: A })
                ] })
              }
            )
          ] })
        }
      ),
      !f && /* @__PURE__ */ s.jsx(os, { data: e, title: U, img: H })
    ] })
  ] });
}, Ms = (a) => (
  // @ts-ignore
  /* @__PURE__ */ s.jsx(xs, { initValue: a, children: /* @__PURE__ */ s.jsx(as, { ...a }) })
);
export {
  Ms as default
};
